#include "share.h"

class THIEnumCOM:public TDebug
{
   private:
      HANDLE hSerial;
   public:
     int _prop_ComPort;
    THI_Event *_data_ComPort;
    THI_Event *_event_onGetInfo;

    HI_WORK_LOC(THIEnumCOM,_work_doInfo)
    {
          string prt=L"COM" ;
          string pnt=L":";
          string t=L"-";
		  bool gps=false;   
      int nm = ReadInteger(_Data,_data_ComPort,_prop_ComPort);
        string nmb=IntToStr(nm);
        string Name = prt+nmb+pnt;
         COMMPROP pr;
         string str1=L"Modem device";
         string str2=L"Unspecified network bridge";
         string str3=L"Parallel port";
         string str4=L"Serial port";
         string str5=L"RS-422 port";
         string str6=L"RS-423 port";
         string str7=L"RS-449 port";
         string str8=L"Scanner device";
         string str9=L"TCP/IP Telnet protocol";
         string str10=L"GPS";
         string str11=L"MaxTx";
         string str12=L"MaxRx";
         string str13=L"LAT protocol";
         string str14=L"Unspecified";
         string str15=L"X.25 standards";
         string str16=L"FAX device";
         string speed1=L"75 bps";
         string speed2=L"110 bps";
         string speed3=L"134,5 bps";
         string speed4=L"150 bps";
         string speed5=L"300 bps";
         string speed6=L"600 bps";
         string speed7=L"1200 bps";
         string speed8=L"1800 bps";
         string speed9=L"2400 bps";
         string speed10=L"4800 bps";
         string speed11=L"7200 bps";
         string speed12=L"9600 bps";
         string speed13=L"14400 bps";
         string speed14=L"19200 bps";
         string speed15=L"38400 bps";
         string speed16=L"56000 bps";
         string speed17=L"57600 bps";
         string speed18=L"115200 bps";
         string speed19=L"128000 bps";
         string speed20=L"Programmable baud rates available";
    
        hSerial = CreateFile(PChar(Name),GENERIC_READ,0,NULL,OPEN_EXISTING,0,NULL);
        if(hSerial==INVALID_HANDLE_VALUE)
	             _hi_onEvent(_event_onGetInfo,t);
                
         else { GetCommProperties(hSerial,&pr);
         
                  _hi_onEvent(_event_onGetInfo,Name);
                  
				        switch(pr.dwProvSubType)
						 {  
                     case PST_MODEM: _hi_onEvent(_event_onGetInfo,str1);
                     break;
                     case PST_NETWORK_BRIDGE: _hi_onEvent(_event_onGetInfo,str2);
                     break;
                     case PST_PARALLELPORT: _hi_onEvent(_event_onGetInfo,str3);
                     break;
                     case PST_RS232: _hi_onEvent(_event_onGetInfo,str4);
                     break;
                     case PST_RS422: _hi_onEvent(_event_onGetInfo,str5);
                     break;
                     case PST_RS423: _hi_onEvent(_event_onGetInfo,str6);
                     break;
                     case PST_RS449: _hi_onEvent(_event_onGetInfo,str7);
                     break;
                     case PST_SCANNER: _hi_onEvent(_event_onGetInfo,str8);
                     break;
                     case PST_TCPIP_TELNET: _hi_onEvent(_event_onGetInfo,str9);
                     break;
                     case PST_LAT: _hi_onEvent(_event_onGetInfo,str13);
                     break;
                     case PST_UNSPECIFIED:{gps=true; _hi_onEvent(_event_onGetInfo,str10);}
                     break;
                     case PST_X25: _hi_onEvent(_event_onGetInfo,str15);
                     break;
                     case PST_FAX: _hi_onEvent(_event_onGetInfo,str16);
                     break;
                     default: {gps=true; _hi_onEvent(_event_onGetInfo,str10);} 
                         }
                         switch(pr.dwMaxBaud)
                         {
                      case BAUD_075: _hi_onEvent(_event_onGetInfo,speed1);
                      break;
                      case BAUD_110: _hi_onEvent(_event_onGetInfo,speed2);
                      break;
                      case BAUD_134_5: _hi_onEvent(_event_onGetInfo,speed3);
                      break;
                      case BAUD_150: _hi_onEvent(_event_onGetInfo,speed4);
                      break;
                      case BAUD_300: _hi_onEvent(_event_onGetInfo,speed5);
                      break;
                      case BAUD_600: _hi_onEvent(_event_onGetInfo,speed6);
                      break;
                      case BAUD_1200: _hi_onEvent(_event_onGetInfo,speed7);
                      break;
                      case BAUD_1800: _hi_onEvent(_event_onGetInfo,speed8);
                      break;
                      case BAUD_2400: _hi_onEvent(_event_onGetInfo,speed9);
                      break;
                      case BAUD_4800: _hi_onEvent(_event_onGetInfo,speed10);
                      break;
                      case BAUD_7200: _hi_onEvent(_event_onGetInfo,speed11);
                      break;
                      case BAUD_9600: _hi_onEvent(_event_onGetInfo,speed12);
                      break;
                      case BAUD_14400: _hi_onEvent(_event_onGetInfo,speed13);
                      break;
                      case BAUD_19200: _hi_onEvent(_event_onGetInfo,speed14);
                      break;
                      case BAUD_38400: _hi_onEvent(_event_onGetInfo,speed15);
                      break;
                      case BAUD_56K: _hi_onEvent(_event_onGetInfo,speed16);
                      break;
                      case BAUD_57600: _hi_onEvent(_event_onGetInfo,speed17);
                      break;
                      case BAUD_115200: _hi_onEvent(_event_onGetInfo,speed18);
                      break;
                      case BAUD_128K: _hi_onEvent(_event_onGetInfo,speed19);
                      break;
                      case BAUD_USER: _hi_onEvent(_event_onGetInfo,speed20);
                      break;
                      default: {if(gps) _hi_onEvent(_event_onGetInfo,speed17);
                                else _hi_onEvent(_event_onGetInfo,t);}
                        }
                    
                      DWORD tx = pr.dwMaxTxQueue;
                      string trans=IntToStr(tx);
                      DWORD rx = pr.dwMaxRxQueue;
                      string recv=IntToStr(rx);
                      _hi_onEvent(_event_onGetInfo,str11+trans);
                      _hi_onEvent(_event_onGetInfo,str12+recv);
                    
                    CloseHandle(hSerial);
              }
      }
};

///////////////////////////////////////////////////////////////////////